<?php
/*
 * Phamm - http://phamm.rhx.it - <phamm@rhx.it>
 * Copyright (C) 2004 Alessandro De Zorzi and Mirko Grava
 *  
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/**
* @package functions
* @subpackage accessories
* @author Alessandro De Zorzi <adezorzi@rhx.it>
**/

// Print e-mail e alias list for a domain
// ********************************************************************

function domain_quota_used ($domain)
{
    global $lang;
    global $connect;
    global $LDAP_BASE;
    global $td_width;
    global $td_width_box;

    $filter="(objectClass=VirtualMailAccount)";
	$attributes = array('quota');

    //$search=ldap_search($connect, "vd=$domain,$LDAP_BASE", $filter, $attributes);
    $search=ldap_list($connect, "vd=$domain,$LDAP_BASE", $filter, $attributes);
	$results = ldap_get_entries($connect, $search);
	
	$num = $results["count"];

	// Free the memory
	ldap_free_result($search);

	$quotaSum = 0;
	
	for ($idx=0; $idx < $num; $idx++)
	{
		$quota = $results[$idx]["quota"][0];
		$quotaSum += $quota;
	}

	return $quotaSum;
}
?>
